﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="configuration.aspx.cs" Inherits="WebAuthProxy.Configuration._default"  MasterPageFile="~/Site.Master" %>
<asp:Content ContentPlaceHolderID="header" runat="server">
    <style>
        #tblUsers
        {
            display:none;
            width:100%;
            

        }
    </style>
</asp:Content>
<asp:Content runat="server" ContentPlaceHolderID="ContentPlaceHolder1">
    <div id="toLoad">
        Please wait while we load configuration settings... <img src="images/loading.gif" />
    </div>
    <div>
        <fieldset>
            <legend>Edit configuration files to change configuration</legend>
            The application is executing in folder '<%=Page.Server.MapPath("~/")%>'. 
            
            <ol>

                <li>
                    At the server, open that folder. Make reserve copy of web.config file. Open that file in an editor such as Notepad.
                </li>
                <li>
                    Navigate to  <code>&lt;appSettings&gt;</code> section. 
                </li>
                <li>Change values of parameter LiquidFilesServiceUrl to Url of your appliance&nbsp;
                    <br />
                    <code>&lt;add key=&quot;LiquidFilesServiceUrl&quot; value=&quot;<%=BaseUrl%>&quot; /&gt;</code></li>
                <li>Navigate to Users section of your appliance <a href="<%=BaseUrl%>/admin/users"><%=BaseUrl%>/admin/users</a>. Pick a user whose API key will be used to grab API keys of other users (normally that user would have administrative permissions).  </li>
                <li>Click on Edit to Edit that user. Copy value from &quot;API Key&quot; field into value of LiquidFilesApiKey in web.config file.
                    <br />
                    <code>&lt;add key=&quot;LiquidFilesApiKey&quot; value=&quot;AAAXXXXQQQQTTTT&quot; /&gt;</code>
                </li>
                <li>WebAuth proxy needs to extract email address of currently authorized user. To do that, you can use either LDAP lookups, or mapping file, or both.<br />
                    By default, LDAP lookups will be executed from under current active user account. You can override this behavior by specifying values for LdapQueryDomainName, LdapQueryUserName, LdapQueryUserPassword values. In this case, LDAP lookups will be executed from that account.
                    <br />
                    <code>&lt;add key=&quot;LdapQueryDomainName&quot; value=&quot;YOURDOMAIN&quot; /&gt;</code>
                <br />
                    <code>&lt;add key=&quot;LdapQueryUserName&quot; value=&quot;AdminUserName&quot; /&gt;</code>
                <br />
                    <code>&lt;add key=&quot;LdapQueryUserPassword&quot; value=&quot;P@ssword&quot; /&gt;</code>

                </li>
                <li>You can change LDAP queries templates by changing LdapQueryTemplate, LdapQueryListUsers values in web.config files. Do not forget that the values have to be xml-encoded.
                    <br />
                    <code>&lt;add key=&quot;LdapQueryTemplate&quot; value=&quot;(&amp;(samAccountName={0})(objectCategory=person)(objectClass=user))&quot; /&gt;</code>
                <br />
                    <code>&lt;add key=&quot;LdapQueryListUsers&quot; value=&quot;(&amp;(objectclass=user)(objectcategory=person))&quot; /&gt;</code>
                </li>

                <li>You can disable LDAP queries entirely by specifying &quot;disable&quot; as value for LdapDisable.
                    <br />
                    <code>&lt;add key=&quot;LdapDisable&quot; value=&quot;disable&quot; /&gt;</code>

                </li>
                <li>If LDAP lookup fails or is disabled, WebAuthProxy will attempt to match current user name to email through Emails.txt file under App_Data folder. The file is plain tab-separated text file.</li>
                
            </ol>
            

        </fieldset>
        

    </div>
     <div class="modal">
        Request in progress...
    </div>
    <script>
        $("#toLoad").on({
            ajaxStart: function () {
                $(this).addClass("loading");
            },
            ajaxStop: function () {
                $(this).removeClass("loading");
            }
        });
        $(document).ready(function () {
            $('#toLoad').load("ConfigContent.aspx");
        });
        var ajaxQueue = $({});
        $.ajaxQueue = function (ajaxOpts) {
            // Hold the original complete function.
            var oldComplete = ajaxOpts.complete;

            // Queue our ajax request.
            ajaxQueue.queue(function (next) {
                // Create a complete callback to fire the next event in the queue.
                ajaxOpts.complete = function () {
                    // Fire the original complete if it was there.
                    if (oldComplete) {
                        oldComplete.apply(this, arguments);
                    }
                    // Run the next query in the queue.
                    next();
                };

                // Run the query.
                $.ajax(ajaxOpts);
            });
        };
        function escapeEmailId(id) {
            return id.replace(/(\W)/g, '\\\\$1');
        }
        var sequenceEl = 100;
        var isLoadingAllUsers = false;
        function loadAllUsers() {
            if (isLoadingAllUsers) return;
            isLoadingAllUsers = true;
            $('#tblUsers').css('display', 'block');
            $.ajaxQueue({
                type: 'GET',
                url: 'getallusers.ashx',
                data: '',
                contentType: 'application/json',
                failure: function (r) { isLoadingAllUsers = false; },
                success: function (r) {
                    isLoadingAllUsers = false;
                    var target = $('#tblUsers > tbody');
                    target.children().remove();
                    if (r == null || !r.Success || r.Users == null) {
                        var msg = r == null ? null : r.Error;
                        if (msg == null || msg == '') {
                            msg = 'You must be administrator to query all users';
                        }
                        target.html('<tr><td colspan=4>' + msg + '</td></tr>');
                    }
                    else  {
                        var a = new Array(), j = -1;
                        for (var i = 0; i < r.Users.length; i++) {
                            var data = r.Users[i];
                            a[++j] = '<tr><td>';
                            a[++j] = (i + 1).toString();
                            a[++j] = '</td><td>';
                            a[++j] = data.UserName;
                            a[++j] = '</td><td>';
                            a[++j] = data.Email;
                            a[++j] = '</td><td><div id="ld';
                            a[++j] = (sequenceEl + i).toString();
                            a[++j] = '"><img src=images/loadkey.gif></div></td></tr>';

                        }
                        target.html(a.join(''));
                        for (var i = 0; i < r.Users.length; i++) {
                            $.ajaxQueue({
                                type: 'GET',
                                url: 'GetUserApiKey.ashx?email=' + encodeURI(r.Users[i].Email)+'&id='+(sequenceEl + i).toString(),
                                //data: JSON.stringify({ email: r.Users[i].Email, id: sequenceEl + i }),
                                contentType: 'application/json',
                                success: function (r) {
                                    var toReplace = r.Success ? '<span class="label label-success">ok</span>' : '';
                                    $('#ld' + r.Id.toString()).replaceWith(toReplace + r.ApiKey);
                                }
                            });
                        }
                        sequenceEl += r.Users.length;
                    }
                    
                }
            });
        }
    </script>

</asp:Content>